%% Demo

clear;

% Initialization

opt.doPlot = 1;   % Plot or not

K      = 3;         % No. endmembers
M      = 5;         % Dimensions
N      = 2000;      % No. samples
sigma2 = 1e-5;      % Noise variance
mix    = [0.7 0.9 1];   % Mixing profile

% Generate synthetic dataset
figure(1);
[X W H opt] = genSynthSimplexData(K, M, N, sigma2, mix, opt);


%% Unmix all datapoints at once

noSamples = 10000;
gamma     = 1e-5;

[W,H,s,nlp] = BayesNMF_Vol(X, K, noSamples, 'skip',0, 'stride',1, 'reg','dist' ,'gamma',gamma, ...
              'progress',true, 'doPlot', 10);

E_res = sum(sum((X-W*H).^2)) / (size(X,1)*size(X,2));
E_s   = sum(sum((X).^2))     / (size(X,1)*size(X,2));
E_wh  = sum(sum((W*H).^2))   / (size(X,1)*size(X,2));
E_res/E_s*100

