function mprogress(n)
% MPROGRESS Display elapsed and remaining time of a for-loop
%
% Example:
%
% for n=1:N
%    ... do stuff ...
%    mprogress(n/N);
% end

% Copyright 2007 Mikkel N. Schmidt, ms@it.dk, www.mikkelschmidt.dk

persistent m t0 c p tp
if nargin==0
    n = 0;
end
if isempty(m), m = inf; end
if isempty(p) || n<m, p = 0.001; end
if n-m>p || n<m || n==1
    % Start new counter
    if n<m
        t0 = cputime;
        c = '0%';
    % Update counter
    else
        fprintf('%c',8*ones(length(c)+1,1)); 
        c = sprintf('%0.f%% (%s) %s', ...
            n*100, mtime(cputime-t0), mtime((cputime-t0)*(1-n)/n));
    end
    disp(c);
    pause(0); 
    drawnow;
    if ~isempty(tp) && n>m
        p = p/(cputime-tp+eps);
    end
    m = n;
    tp = cputime;
end


function tstr = mtime(t)
if t<60*60
    tstr = sprintf('%02.f:%02.f', floor(t/60), mod(t,60));
elseif t<60*60*24
    tstr = sprintf('%02.f:%02.f:%02.f', floor(t/60/60), mod(floor(t/60),60), mod(t,60));
else
    tstr = sprintf('%0.f - %02.f:%02.f:%02.f', floor(t/60/60/24), mod(floor(t/60/60),24), mod(floor(t/60),60), mod(t,60));
end